//******************************************************************************
// This class is part of the Sizmek DCO Auto Template Ad Feature
// ALL RIGHTS RESERVED TO © 2017 Sizmek.
//******************************************************************************
//******************************************************************************

(function () {
	// Define Method - Update "FeatureName" with name of Ad Feature
	window.DCOAutoTemplate160x600 = function (_c) {

		"use strict";
		// Save Reference to Script Name
		var scriptName = "DCOAutoTemplate160x600";
		// Script Version
		var scriptVersion = "3.0.0";
		// Last Modified
		var lastModified = "2017-11-16";
		// Last Uploaded
		var lastUploaded = "2017-11-16";
		// Template Version
		var templateVersion = "2.0.3";
		// Block Id
		var blockId = 6175;

		// Establish Boolean for tracking
		var isDebug = false;
		// Establish Boolean for tracking
		var trackOnce = true;
		//Initializing button text variable
		var buttonText = "";
		var heading_css, heading_css_array, heading1_color, heading1_font, heading2_color, heading2_font, heading3_color, heading3_font,
			headline_1, headline_2, headline_3, disclaimer, copyrights, image, logo, border, align, ctaColor, Standalone, bgColor, ctaText;

		// Create Event Handlers for class
		var addEventListener = function (_e, _m, _b) {
			window.addEventListener(_e, _m, _b);
		};
		// Remove Event Handlers for class
		var removeEventListener = function (_e, _m, _b) {
			window.removeEventListener(_e, _m, _b);
		};

		// Call Init Method once AdKit is loaded
		adkit.onReady(function () {
			init();
		});

		// Set up Script
		var init = function () {
			// Track Ad Feature
			trackAdFeatures("data_impression", "AF_" + scriptName + "_" + blockId);
			// Set Up Ad
			setUpAd();
		};

		// Initialize DCO template
		var setUpAd = function () {
			// initializing all variables
			// First check the values from the config.js file and then check the default values
			// Initializing Heading Style CSS
			heading_css = adkit.getSVData("heading_style");
			// Converting comma separated string into array and parsing out vars
			heading_css_array = heading_css.split(",");
			heading1_color = heading_css_array[0];
			heading1_font = heading_css_array[1];
			heading2_color = heading_css_array[2];
			heading2_font = heading_css_array[3];
			heading3_color = heading_css_array[4];
			heading3_font = heading_css_array[5];

			// Initializing all config value
			headline_1 = adkit.getSVData("headline_1");
			headline_2 = adkit.getSVData("headline_2");
			headline_3 = adkit.getSVData("headline_3");
			disclaimer = adkit.getSVData("disclaimer");
			copyrights = adkit.getSVData("copyrights");
			image = adkit.getSVData("image");
			logo = adkit.getSVData("logo");
			border = adkit.getSVData("border");
			align = adkit.getSVData("align");
			ctaColor = adkit.getSVData("ctaColor");
			Standalone = adkit.getSVData("Standalone");
			bgColor = adkit.getSVData("bgColor");
			ctaText = adkit.getSVData("ctaText");
			buttonText = adkit.getSVData("ctaText");

			// Setting button width after calculating its text
			$("#ctaBtn").css('width', parseFloat(textWidth(ctaText) + 30) + "px");

			// Checking Standalone Status
			if (Standalone == "false") {
				// Set variables and start animation
				SetVariables();
				// Begin Banner animation
				bannerAnimation();
			} else {
				//If standalone is true then hide everything and display a Static Image
				$("#wrapper").prepend('<img id="theImg" src="images/standalone.jpg" />');
				$("#ctaBtn").hide();
				$("#logo").hide();
				$("#images").hide();
				$("#headlineText").hide();
				$("#mainContainer").hide();
			}

			// Handle CTA Clickthrough
			$("#mainContainer").click(function () {
				EB.clickthrough();
			});
		};

		var SetVariables = function () {
			$("#headline1Txt").text(headline_1);
			$("#headline2Txt").text(headline_2);
			$("#headline3Txt").text(headline_3);
			$("#copyrights").text(copyrights);
			$("#disclaimer").text(disclaimer);
			$("#Image_Car").attr("src", image);
			$("#wrapper").css("background-color", bgColor);
			$("#ctaBtn").text(ctaText);
			$("#Imglogo").attr("src", logo);
			$("#headlineText").css("text-align", "center");
			$("#headline1Txt").css("color", heading1_color);
			$("#headline1Txt").css("font-size", heading1_font);
			$("#headline2Txt").css("color", heading2_color);
			$("#headline2Txt").css("font-size", heading2_font);
			$("#headline3Txt").css("color", heading3_color);
			$("#headline3Txt").css("font-size", heading3_font);

			// Ad Alignment Function
			// Animate Elements according to the Alignment Value
			switch (align) {
			case "topcenter":
				$("#headline1Txt, #headline2Txt, #headline3Txt").css("top", "20px");
				break;
			default:
				$("#Image_Car").css("top", "10px");
				$("#headline1Txt, #headline2Txt, #headline3Txt").css("top", "200px");
			}

			// Setting button properties
			$(".btn-primary").css("background-image", "-moz-linear-gradient(top," + ctaColor + ", " + ctaColor + ")");
			$(".btn-primary").css("background-color", "" + ctaColor + "");
			$(".btn-primary").css("background-image", "-o-linear-gradient(top," + ctaColor + ", " + ctaColor + ")");
			$(".btn-primary").css("background-image", "linear-gradient(to bottom," + ctaColor + ", " + ctaColor + ")");
			$(".btn-primary[disabled]").css("background-color", "" + ctaColor + "");

			// Remove Borders if 'border=false'
			if (border == "false") {
				$("#mainContainer").css("border", "none");
			}
		};

		// Handle Animation
		var bannerAnimation = function () {
			//Starting Image Animation
			$("#Image_Car").animate({
				left: "30"
			}, 400, function () {
				$("#Image_Car").animate({
					left: "10"
				}, 200);
			});

			// Starting Text Animation
			$("#headline1Txt").fadeIn(3000);

			// Setting Timeout to animate HeadlineText2 and HeadlineText3
			setTimeout(function () {
				$("#headline2Txt").animate({
					left: "20"
				}, 500, function () {
					$("#headline3Txt").animate({
						left: "20"
					}, 500, function () {
						$("#headline3Txt").animate({
							left: "10"
						}, 200);
					});
					$("#headline2Txt").animate({
						left: "10"
					}, 200);

					//Clearing Button text
					$("#ctaBtn").text("");

					//Caling Button Text animation function
					button_effect();
				});
			}, 1000);

			//Handle Disclaimer mouse hover animation
			$("#disclaimer").hover(
				function () {

					//Adding Hovered Class
					$("#wrapper").addClass("hovered");
				},
				function () {

					//Removing Hovered Class
					$("#wrapper").removeClass("hovered");
				}
			);

			// Handle Template mouse hover animation
			$("#mainContainer").hover(function () {
				// Adding Transition Class
				$("#Image_Car").addClass("transition");
				$("#ctaBtn").addClass("transition");
				$("#Image_logo img").addClass("transition");

			}, function () {

				// Removing Transition Class
				$("#Image_Car").removeClass("transition");
				$("#ctaBtn").removeClass("transition");
				$("#Image_logo img").removeClass("transition");
			});

			// Button Animation Function
			function button_effect() {
				//Grabbing Button Text
				var string = buttonText;
				//Animating Button Text
				var q = jQuery.map(string.split(""), function (letter) {
					return $("<span>" + letter + "</span>");
				});
				//Setting destination value to Button
				var dest = $("#ctaBtn");
				var c = 0;
				var i = setInterval(function () {

					//Applying FadeIn Animation
					q[c].appendTo(dest).hide().fadeIn(200);
					c += 1;
					if (c >= q.length) clearInterval(i);
				}, 30);
			}
		};

		// Calculating button text width in pixels
		var textWidth = function (text) {
			var calc = '<span style="display:none">' + text + '</span>';
			$("body").append(calc);
			var width = $("body").find("span:last").width();
			$("body").find("span:last").remove();
			return width;
		};

		// DO NOT REMOVE THE FOLLOWING
		//=================================================
		// Utility Functions
		//-------------------------------------------------

		// Debugging
		var log = function () { // this is a closure-compiled version of the original code
			if (isDebug) {
				var b, a;
				b = Array.prototype.slice.call(arguments);
				a = new Date();
				a = scriptName + " (" + a.getFullYear() + "-" + a.getMonth() + "-" + a.getDate() + " " + (("0" + a.getHours()).slice(-2)) + ":" + (("0" + a.getMinutes()).slice(-2)) + ":" + (("0" + a.getSeconds()).slice(-2)) + "." + (("00" + a.getMilliseconds()).slice(-3)) + "): ";
				b.unshift(a);
				try {
					window.console && console.log && (console.log.apply ? console.log.apply(console, b) : console.log(b));
				}
				catch (d) {}
			}
		};

		// Track Ad Features - accepts interaction name and impression type
		var trackAdFeatures = function (_interaction, _noun) {
			// Establish var to track local mode
			var isServed;
			// Verify ad is not local
			try {
				isServed = EB._isServingMode();
			}
			catch (err) {}

			if (isServed && trackOnce) {
				try {
					// Update Boolean
					trackOnce = false;
					// Grab Version ID
					var adId = EB._adConfig.adId;
					// Establish reference for Version id
					var versionID;
					// Grab Version ID for mass versioning
					try {
						versionID = EB._adConfig.massVersioning.adVersions.split("_")[0];
					}
					catch (err) {
						versionID = "";
					}
					// Determine if tag is SAS
					var isNXT = (adId.toString().length >= 10);
					// Build Base Url for SAS and MDX
					var baseURL = (isNXT) ? "https://bs.serving-sys.com/BurstingPipe/adServer.bs?cn=tf&c=19&mc=imp&pli=16478984&PluID=0&ord=%time%&rtu=-1&pcp=$$adID=" + adId + "|vId=" + versionID + "|interactionName=" : "https://bs.serving-sys.com/Serving/adServer.bs?cn=display&c=19&pli=1073952795&adid=1073972634&ord=[timestamp]&rtu=-1&pcp=$$adID=" + adId + "|vID=" + versionID + "|interactionName=";
					// Build Tracking Pixel
					var trackingPixel = baseURL + _interaction + "|noun=" + _noun + "$$";
					// Fire Tracking Pixel by creating a new image.
					new Image().src = trackingPixel;

				}
				catch (err) {}
			}
		};

		// Return functions you want publically available
		return {
			addEventListener: addEventListener,
			removeEventListener: removeEventListener
		};

	};
}());
